'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _laravelSocketClient = require('laravel-socket-client');

var _laravelSocketClient2 = _interopRequireDefault(_laravelSocketClient);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function plugin(Vue) {

    if (plugin.installed) {
        return;
    }

    if (!Vue.prototype.hasOwnProperty('$http')) {
        console.error('Please install vue-resource.');
    }

    if (!Vue.prototype.hasOwnProperty('$events')) {
        console.error('Please install vue-events.');
    }

    var socket = new _laravelSocketClient2.default();

    Object.defineProperty(Vue.prototype, '$socket', {
        get: function get() {
            return this == this.$root ? socket : this.$root.$socket;
        }
    });

    Vue.mixin({
        beforeCreate: function beforeCreate() {
            listenForSocketEvent(this);
        },
        init: function init() {
            listenForSocketEvent(this);
        }
    });
}

function listenForSocketEvent(vm) {
    vm.$socket.on('event', function (event) {
        vm.$events.fire(event.name, event.data);
    });
}

exports.default = plugin;